<?php
/**
 * This class adds the options with the related callbacks and validations.
 *
 * @package helpful-pro
 */

/**
 * This class adds the options with the related callbacks and validations.
 */
class Daexthefup_Menu_Options {

	private $shared = null;

	public function __construct( $shared ) {

		// assign an instance of the plugin info.
		$this->shared = $shared;
	}

	/**
	 * Register the plugin options.
	 *
	 * @return void
	 */
	public function register_options() {

		// Section Content --------------------------------------------------------------------------------------------.
		add_settings_section(
			'daexthefup_content_settings_section',
			null,
			null,
			'daexthefup_content_options'
		);

		add_settings_field(
			'position',
			esc_html__( 'Position', 'helpful-pro' ),
			array( $this, 'position_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_position',
			'sanitize_key'
		);

		add_settings_field(
			'title',
			esc_html__( 'Title', 'helpful-pro' ),
			array( $this, 'title_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_title',
			'sanitize_text_field'
		);

		add_settings_field(
			'layout',
			esc_html__( 'Layout', 'helpful-pro' ),
			array( $this, 'layout_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_layout',
			'sanitize_key'
		);

		add_settings_field(
			'alignment',
			esc_html__( 'Alignment', 'helpful-pro' ),
			array( $this, 'alignment_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_alignment',
			'sanitize_key'
		);

		add_settings_field(
			'button_type',
			esc_html__( 'Rating Button Type', 'helpful-pro' ),
			array( $this, 'button_type_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_button_type',
			'sanitize_key'
		);

		add_settings_field(
			'show_rating_number',
			esc_html__( 'Show Rating Number', 'helpful-pro' ),
			array( $this, 'show_rating_number_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_show_rating_number',
			'sanitize_key'
		);

		add_settings_field(
			'positive_feedback_icon',
			esc_html__( 'Positive Rating Icon', 'helpful-pro' ),
			array( $this, 'positive_feedback_icon_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_positive_feedback_icon',
			'sanitize_key'
		);

		add_settings_field(
			'positive_feedback_text',
			esc_html__( 'Positive Rating Text', 'helpful-pro' ),
			array( $this, 'positive_feedback_text_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_positive_feedback_text',
			'sanitize_text_field'
		);

		add_settings_field(
			'negative_feedback_icon',
			esc_html__( 'Negative Rating Icon', 'helpful-pro' ),
			array( $this, 'negative_feedback_icon_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_negative_feedback_icon',
			'sanitize_key'
		);

		add_settings_field(
			'negative_feedback_text',
			esc_html__( 'Negative Rating Text', 'helpful-pro' ),
			array( $this, 'negative_feedback_text_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_negative_feedback_text',
			'sanitize_text_field'
		);

		add_settings_field(
			'comment_form',
			esc_html__( 'Comment Form', 'helpful-pro' ),
			array( $this, 'comment_form_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_comment_form',
			'sanitize_key'
		);

		add_settings_field(
			'comment_form_textarea_label_positive_feedback',
			esc_html__( 'Textarea Label Positive Rating', 'helpful-pro' ),
			array( $this, 'comment_form_textarea_label_positive_feedback_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_comment_form_textarea_label_positive_feedback',
			'sanitize_text_field'
		);

		add_settings_field(
			'comment_form_textarea_label_negative_feedback',
			esc_html__( 'Textarea Label Negative Rating', 'helpful-pro' ),
			array( $this, 'comment_form_textarea_label_negative_feedback_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_comment_form_textarea_label_negative_feedback',
			'sanitize_text_field'
		);

		add_settings_field(
			'comment_form_textarea_placeholder',
			esc_html__( 'Textarea Placeholder', 'helpful-pro' ),
			array( $this, 'comment_form_textarea_placeholder_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_comment_form_textarea_placeholder',
			'sanitize_text_field'
		);

		add_settings_field(
			'comment_form_button_submit_text',
			esc_html__( 'Submit Button Text', 'helpful-pro' ),
			array( $this, 'comment_form_button_submit_text_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_comment_form_button_submit_text',
			'sanitize_text_field'
		);

		add_settings_field(
			'comment_form_button_cancel_text',
			esc_html__( 'Cancel Button Text', 'helpful-pro' ),
			array( $this, 'comment_form_button_cancel_text_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_comment_form_button_cancel_text',
			'sanitize_text_field'
		);

		add_settings_field(
			'successful_submission_text',
			esc_html__( 'Successful Submission Text', 'helpful-pro' ),
			array( $this, 'successful_submission_text_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_successful_submission_text',
			'sanitize_text_field'
		);

		add_settings_field(
			'background',
			esc_html__( 'Container Background', 'helpful-pro' ),
			array( $this, 'background_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_background',
			'sanitize_key'
		);

		add_settings_field(
			'border',
			esc_html__( 'Container Border', 'helpful-pro' ),
			array( $this, 'border_callback' ),
			'daexthefup_content_options',
			'daexthefup_content_settings_section'
		);

		register_setting(
			'daexthefup_content_options',
			'daexthefup_border',
			'sanitize_key'
		);

		// Section Fonts ------------------------------------------------------------------------------------------------
		add_settings_section(
			'daexthefup_fonts_settings_section',
			null,
			null,
			'daexthefup_fonts_options'
		);

		add_settings_field(
			'title_font_family',
			esc_html__( 'Title Font Family', 'helpful-pro' ),
			array( $this, 'title_font_family_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_title_font_family',
			'sanitize_text_field'
		);

		add_settings_field(
			'title_font_size',
			esc_html__( 'Title Font Size', 'helpful-pro' ),
			array( $this, 'title_font_size_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_title_font_size',
			'sanitize_key'
		);

		add_settings_field(
			'title_font_style',
			esc_html__( 'Title Font Style', 'helpful-pro' ),
			array( $this, 'title_font_style_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_title_font_style',
			'sanitize_key'
		);

		add_settings_field(
			'title_font_weight',
			esc_html__( 'Title Font Weight', 'helpful-pro' ),
			array( $this, 'title_font_weight_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_title_font_weight',
			'sanitize_key'
		);

		add_settings_field(
			'title_line_height',
			esc_html__( 'Title Line Height', 'helpful-pro' ),
			array( $this, 'title_line_height_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_title_line_height',
			'sanitize_key'
		);

		add_settings_field(
			'rating_button_font_family',
			esc_html__( 'Rating Button Font Family', 'helpful-pro' ),
			array( $this, 'rating_button_font_family_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_rating_button_font_family'
		);

		add_settings_field(
			'rating_button_font_size',
			esc_html__( 'Rating Button Font Size', 'helpful-pro' ),
			array( $this, 'rating_button_font_size_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_rating_button_font_size'
		);

		add_settings_field(
			'rating_button_font_style',
			esc_html__( 'Rating Button Font Style', 'helpful-pro' ),
			array( $this, 'rating_button_font_style_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_rating_button_font_style'
		);

		add_settings_field(
			'rating_button_font_weight',
			esc_html__( 'Rating Button Font Weight', 'helpful-pro' ),
			array( $this, 'rating_button_font_weight_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_rating_button_font_weight'
		);

		add_settings_field(
			'rating_button_line_height',
			esc_html__( 'Rating Button Line Height', 'helpful-pro' ),
			array( $this, 'rating_button_line_height_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_rating_button_line_height'
		);

		add_settings_field(
			'base_font_family',
			esc_html__( 'Base Font Family', 'helpful-pro' ),
			array( $this, 'base_font_family_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_base_font_family'
		);

		add_settings_field(
			'base_font_size',
			esc_html__( 'Base Font Size', 'helpful-pro' ),
			array( $this, 'base_font_size_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_base_font_size'
		);

		add_settings_field(
			'base_font_style',
			esc_html__( 'Base Font Style', 'helpful-pro' ),
			array( $this, 'base_font_style_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_base_font_style'
		);

		add_settings_field(
			'base_font_weight',
			esc_html__( 'Base Font Weight', 'helpful-pro' ),
			array( $this, 'base_font_weight_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_base_font_weight'
		);

		add_settings_field(
			'base_line_height',
			esc_html__( 'Base Line Height', 'helpful-pro' ),
			array( $this, 'base_line_height_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_base_line_height'
		);

		add_settings_field(
			'comment_textarea_font_family',
			esc_html__( 'Textarea Font Family', 'helpful-pro' ),
			array( $this, 'comment_textarea_font_family_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_comment_textarea_font_family'
		);

		add_settings_field(
			'comment_textarea_font_size',
			esc_html__( 'Textarea Font Size', 'helpful-pro' ),
			array( $this, 'comment_textarea_font_size_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_comment_textarea_font_size'
		);

		add_settings_field(
			'comment_textarea_font_style',
			esc_html__( 'Textarea Font Style', 'helpful-pro' ),
			array( $this, 'comment_textarea_font_style_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_comment_textarea_font_style'
		);

		add_settings_field(
			'comment_textarea_font_weight',
			esc_html__( 'Textarea Font Weight', 'helpful-pro' ),
			array( $this, 'comment_textarea_font_weight_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_comment_textarea_font_weight'
		);

		add_settings_field(
			'comment_textarea_line_height',
			esc_html__( 'Textarea Line Height', 'helpful-pro' ),
			array( $this, 'comment_textarea_line_height_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_comment_textarea_line_height'
		);

		add_settings_field(
			'button_font_family',
			esc_html__( 'Standard Button Font Family', 'helpful-pro' ),
			array( $this, 'button_font_family_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_button_font_family'
		);

		add_settings_field(
			'button_font_size',
			esc_html__( 'Standard Button Font Size', 'helpful-pro' ),
			array( $this, 'button_font_size_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_button_font_size'
		);

		add_settings_field(
			'button_font_style',
			esc_html__( 'Standard Button Font Style', 'helpful-pro' ),
			array( $this, 'button_font_style_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_button_font_style'
		);

		add_settings_field(
			'button_font_weight',
			esc_html__( 'Standard Button Font Weight', 'helpful-pro' ),
			array( $this, 'button_font_weight_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_button_font_weight'
		);

		add_settings_field(
			'button_line_height',
			esc_html__( 'Standard Button Line Height', 'helpful-pro' ),
			array( $this, 'button_line_height_callback' ),
			'daexthefup_fonts_options',
			'daexthefup_fonts_settings_section'
		);

		register_setting(
			'daexthefup_fonts_options',
			'daexthefup_button_line_height'
		);

		// Section Colors ---------------------------------------------------------------------------------------------.
		add_settings_section(
			'daexthefup_colors_settings_section',
			null,
			null,
			'daexthefup_colors_options'
		);

		add_settings_field(
			'title_font_color',
			esc_html__( 'Title Font Color', 'helpful-pro' ),
			array( $this, 'title_font_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_title_font_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'rating_button_font_color',
			esc_html__( 'Rating Button Font Color', 'helpful-pro' ),
			array( $this, 'rating_button_font_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_rating_button_font_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'rating_button_background_color',
			esc_html__( 'Rating Button Background Color', 'helpful-pro' ),
			array( $this, 'rating_button_background_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_rating_button_background_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'button_icon_primary_color',
			esc_html__( 'Icon Primary Color', 'helpful-pro' ),
			array( $this, 'button_icon_primary_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_button_icon_primary_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'button_icon_secondary_color',
			esc_html__( 'Icon Secondary Color', 'helpful-pro' ),
			array( $this, 'button_icon_secondary_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_button_icon_secondary_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'button_icon_primary_color_positive_selected',
			esc_html__( 'Icon Primary Color Positive Selected', 'helpful-pro' ),
			array( $this, 'button_icon_primary_color_positive_selected_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_button_icon_primary_color_positive_selected',
			'sanitize_hex_color'
		);

		add_settings_field(
			'button_icon_secondary_color_positive_selected',
			esc_html__( 'Icon Secondary Color Positive Selected', 'helpful-pro' ),
			array( $this, 'button_icon_secondary_color_positive_selected_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_button_icon_secondary_color_positive_selected',
			'sanitize_hex_color'
		);

		add_settings_field(
			'button_icon_primary_color_negative_selected',
			esc_html__( 'Icon Primary Color Negative Selected', 'helpful-pro' ),
			array( $this, 'button_icon_primary_color_negative_selected_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_button_icon_primary_color_negative_selected',
			'sanitize_hex_color'
		);

		add_settings_field(
			'button_icon_secondary_color_negative_selected',
			esc_html__( 'Icon Secondary Color Negative Selected', 'helpful-pro' ),
			array( $this, 'button_icon_secondary_color_negative_selected_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_button_icon_secondary_color_negative_selected',
			'sanitize_hex_color'
		);

		add_settings_field(
			'button_icons_border_color',
			esc_html__( 'Icons Border Color', 'helpful-pro' ),
			array( $this, 'button_icons_border_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_button_icons_border_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'label_font_color',
			esc_html__( 'Label Font Color', 'helpful-pro' ),
			array( $this, 'label_font_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_label_font_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'character_counter_font_color',
			esc_html__( 'Character Counter Font Color', 'helpful-pro' ),
			array( $this, 'character_counter_font_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_character_counter_font_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'comment_textarea_font_color',
			esc_html__( 'Textarea Font Color', 'helpful-pro' ),
			array( $this, 'comment_textarea_font_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_comment_textarea_font_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'comment_textarea_background_color',
			esc_html__( 'Textarea Background Color', 'helpful-pro' ),
			array( $this, 'comment_textarea_background_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_comment_textarea_background_color'
		);

		add_settings_field(
			'comment_textarea_border_color',
			esc_html__( 'Textarea Border Color', 'helpful-pro' ),
			array( $this, 'comment_textarea_border_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_comment_textarea_border_color'
		);

		add_settings_field(
			'comment_textarea_border_color_selected',
			esc_html__( 'Textarea Border Color Selected', 'helpful-pro' ),
			array( $this, 'comment_textarea_border_color_selected_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_comment_textarea_border_color_selected',
			'sanitize_hex_color'
		);

		add_settings_field(
			'primary_button_background_color',
			esc_html__( 'Primary Button Background Color', 'helpful-pro' ),
			array( $this, 'primary_button_background_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_primary_button_background_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'primary_button_border_color',
			esc_html__( 'Primary Button Border Color', 'helpful-pro' ),
			array( $this, 'primary_button_border_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_primary_button_border_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'primary_button_font_color',
			esc_html__( 'Primary Button Font Color', 'helpful-pro' ),
			array( $this, 'primary_button_font_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_primary_button_font_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'secondary_button_background_color',
			esc_html__( 'Secondary Button Background Color', 'helpful-pro' ),
			array( $this, 'secondary_button_background_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_secondary_button_background_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'secondary_button_border_color',
			esc_html__( 'Secondary Button Border Color', 'helpful-pro' ),
			array( $this, 'secondary_button_border_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_secondary_button_border_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'secondary_button_font_color',
			esc_html__( 'Secondary Button Font Color', 'helpful-pro' ),
			array( $this, 'secondary_button_font_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_secondary_button_font_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'successful_submission_font_color',
			esc_html__( 'Successful Submission Font Color', 'helpful-pro' ),
			array( $this, 'successful_submission_font_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_successful_submission_font_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'background_color',
			esc_html__( 'Container Background Color', 'helpful-pro' ),
			array( $this, 'background_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_background_color',
			'sanitize_hex_color'
		);

		add_settings_field(
			'border_color',
			esc_html__( 'Container Border Color', 'helpful-pro' ),
			array( $this, 'border_color_callback' ),
			'daexthefup_colors_options',
			'daexthefup_colors_settings_section'
		);

		register_setting(
			'daexthefup_colors_options',
			'daexthefup_border_color',
			'sanitize_hex_color'
		);

		// Spacing ----------------------------------------------------------------------------------------------------.
		add_settings_section(
			'daexthefup_spacing_settings_section',
			null,
			null,
			'daexthefup_spacing_options'
		);

		add_settings_field(
			'container_horizontal_padding',
			esc_html__( 'Container Horizontal Padding', 'helpful-pro' ),
			array( $this, 'container_horizontal_padding_callback' ),
			'daexthefup_spacing_options',
			'daexthefup_spacing_settings_section'
		);

		register_setting(
			'daexthefup_spacing_options',
			'daexthefup_container_horizontal_padding',
			'sanitize_key'
		);

		add_settings_field(
			'container_vertical_padding',
			esc_html__( 'Container Vertical Padding', 'helpful-pro' ),
			array( $this, 'container_vertical_padding_callback' ),
			'daexthefup_spacing_options',
			'daexthefup_spacing_settings_section'
		);

		register_setting(
			'daexthefup_spacing_options',
			'daexthefup_container_vertical_padding',
			'sanitize_key'
		);

		add_settings_field(
			'container_horizontal_margin',
			esc_html__( 'Container Horizontal Margin', 'helpful-pro' ),
			array( $this, 'container_horizontal_margin_callback' ),
			'daexthefup_spacing_options',
			'daexthefup_spacing_settings_section'
		);

		register_setting(
			'daexthefup_spacing_options',
			'daexthefup_container_horizontal_margin',
			'sanitize_key'
		);

		add_settings_field(
			'container_vertical_margin',
			esc_html__( 'Container Vertical Margin', 'helpful-pro' ),
			array( $this, 'container_vertical_margin_callback' ),
			'daexthefup_spacing_options',
			'daexthefup_spacing_settings_section'
		);

		register_setting(
			'daexthefup_spacing_options',
			'daexthefup_container_vertical_margin',
			'sanitize_key'
		);

		add_settings_field(
			'border_radius',
			esc_html__( 'Border Radius', 'helpful-pro' ),
			array( $this, 'border_radius_callback' ),
			'daexthefup_spacing_options',
			'daexthefup_spacing_settings_section'
		);

		register_setting(
			'daexthefup_spacing_options',
			'daexthefup_border_radius',
			'sanitize_key'
		);

		// Section Analysis -------------------------------------------------------------------------------------------.
		add_settings_section(
			'daexthefup_analysis_settings_section',
			null,
			null,
			'daexthefup_analysis_options'
		);

		add_settings_field(
			'set_max_execution_time',
			esc_html__( 'Set Max Execution Time', 'helpful-pro' ),
			array( $this, 'set_max_execution_time_callback' ),
			'daexthefup_analysis_options',
			'daexthefup_analysis_settings_section'
		);

		register_setting(
			'daexthefup_analysis_options',
			'daexthefup_set_max_execution_time',
			'sanitize_text_field'
		);

		add_settings_field(
			'max_execution_time_value',
			esc_html__( 'Max Execution Time Value', 'helpful-pro' ),
			array( $this, 'max_execution_time_value_callback' ),
			'daexthefup_analysis_options',
			'daexthefup_analysis_settings_section'
		);

		register_setting(
			'daexthefup_analysis_options',
			'daexthefup_max_execution_time_value',
			'sanitize_text_field'
		);

		add_settings_field(
			'set_memory_limit',
			esc_html__( 'Set Memory Limit', 'helpful-pro' ),
			array( $this, 'set_memory_limit_callback' ),
			'daexthefup_analysis_options',
			'daexthefup_analysis_settings_section'
		);

		register_setting(
			'daexthefup_analysis_options',
			'daexthefup_set_memory_limit',
			'sanitize_text_field'
		);

		add_settings_field(
			'memory_limit_value',
			esc_html__( 'Memory Limit Value', 'helpful-pro' ),
			array( $this, 'memory_limit_value_callback' ),
			'daexthefup_analysis_options',
			'daexthefup_analysis_settings_section'
		);

		register_setting(
			'daexthefup_analysis_options',
			'daexthefup_memory_limit_value',
			'sanitize_text_field'
		);

		add_settings_field(
			'limit_posts_analysis',
			esc_html__( 'Limit Posts Analysis', 'helpful-pro' ),
			array( $this, 'limit_posts_analysis_callback' ),
			'daexthefup_analysis_options',
			'daexthefup_analysis_settings_section'
		);

		register_setting(
			'daexthefup_analysis_options',
			'daexthefup_limit_posts_analysis',
			'sanitize_key'
		);

		add_settings_field(
			'analysis_post_types',
			esc_html__( 'Post Types', 'helpful-pro' ),
			array( $this, 'analysis_post_types_callback' ),
			'daexthefup_analysis_options',
			'daexthefup_analysis_settings_section'
		);

		register_setting(
			'daexthefup_analysis_options',
			'daexthefup_analysis_post_types',
			array( $this, 'analysis_post_types_validation' )
		);

		// Section Capabilities ---------------------------------------------------------------------------------------.
		add_settings_section(
			'daexthefup_capabilities_settings_section',
			null,
			null,
			'daexthefup_capabilities_options'
		);

		add_settings_field(
			'statistics_menu_capability',
			esc_html__( 'Statistics Menu', 'helpful-pro' ),
			array( $this, 'statistics_menu_capability_callback' ),
			'daexthefup_capabilities_options',
			'daexthefup_capabilities_settings_section'
		);

		register_setting(
			'daexthefup_capabilities_options',
			'daexthefup_statistics_menu_capability',
			'sanitize_key'
		);

		add_settings_field(
			'maintenance_menu_capability',
			esc_html__( 'Maintenance Menu', 'helpful-pro' ),
			array( $this, 'maintenance_menu_capability_callback' ),
			'daexthefup_capabilities_options',
			'daexthefup_capabilities_settings_section'
		);

		register_setting(
			'daexthefup_capabilities_options',
			'daexthefup_maintenance_menu_capability',
			'sanitize_key'
		);

		// Section Advanced -------------------------------------------------------------------------------------------.
		add_settings_section(
			'daexthefup_advanced_settings_section',
			null,
			null,
			'daexthefup_advanced_options'
		);

		add_settings_field(
			'test_mode',
			esc_html__( 'Test Mode', 'helpful-pro' ),
			array( $this, 'test_mode_callback' ),
			'daexthefup_advanced_options',
			'daexthefup_advanced_settings_section'
		);

		register_setting(
			'daexthefup_advanced_options',
			'daexthefup_test_mode',
			'sanitize_key'
		);

		add_settings_field(
			'assets_mode',
			esc_html__( 'Assets Mode', 'helpful-pro' ),
			array( $this, 'assets_mode_callback' ),
			'daexthefup_advanced_options',
			'daexthefup_advanced_settings_section'
		);

		register_setting(
			'daexthefup_advanced_options',
			'daexthefup_assets_mode',
			'sanitize_key'
		);

		add_settings_field(
			'post_types',
			esc_html__( 'Post Types', 'helpful-pro' ),
			array( $this, 'post_types_callback' ),
			'daexthefup_advanced_options',
			'daexthefup_advanced_settings_section'
		);

		register_setting(
			'daexthefup_advanced_options',
			'daexthefup_post_types',
			array( $this, 'post_types_validation' )
		);

		add_settings_field(
			'pagination_items',
			esc_html__( 'Pagination Items', 'helpful-pro' ),
			array( $this, 'pagination_items_callback' ),
			'daexthefup_advanced_options',
			'daexthefup_advanced_settings_section'
		);

		register_setting(
			'daexthefup_advanced_options',
			'daexthefup_pagination_items',
			'sanitize_key'
		);

		add_settings_field(
			'google_font_url',
			esc_html__( 'Google Font URL', 'helpful-pro' ),
			array( $this, 'google_font_url_callback' ),
			'daexthefup_advanced_options',
			'daexthefup_advanced_settings_section'
		);

		register_setting(
			'daexthefup_advanced_options',
			'daexthefup_google_font_url',
			'sanitize_text_field'
		);

		add_settings_field(
			'textarea_characters',
			esc_html__( 'Textarea Characters', 'helpful-pro' ),
			array( $this, 'textarea_characters_callback' ),
			'daexthefup_advanced_options',
			'daexthefup_advanced_settings_section'
		);

		register_setting(
			'daexthefup_advanced_options',
			'daexthefup_textarea_characters',
			'sanitize_text_field'
		);

		add_settings_field(
			'unique_submission',
			esc_html__( 'Unique Submission', 'helpful-pro' ),
			array( $this, 'unique_submission_callback' ),
			'daexthefup_advanced_options',
			'daexthefup_advanced_settings_section'
		);

		register_setting(
			'daexthefup_advanced_options',
			'daexthefup_unique_submission',
			'sanitize_text_field'
		);

		add_settings_field(
			'cookie_expiration',
			esc_html__( 'Cookie Expiration', 'helpful-pro' ),
			array( $this, 'cookie_expiration_callback' ),
			'daexthefup_advanced_options',
			'daexthefup_advanced_settings_section'
		);

		register_setting(
			'daexthefup_advanced_options',
			'daexthefup_cookie_expiration',
			'sanitize_text_field'
		);

		add_settings_field(
			'required_capability',
			esc_html__( 'Required Capability', 'helpful-pro' ),
			array( $this, 'required_capability_callback' ),
			'daexthefup_advanced_options',
			'daexthefup_advanced_settings_section'
		);

		register_setting(
			'daexthefup_advanced_options',
			'daexthefup_required_capability',
			'sanitize_key'
		);

		add_settings_field(
			'character_counter',
			esc_html__( 'Character Counter', 'helpful-pro' ),
			array( $this, 'character_counter_callback' ),
			'daexthefup_advanced_options',
			'daexthefup_advanced_settings_section'
		);

		register_setting(
			'daexthefup_advanced_options',
			'daexthefup_character_counter',
			'sanitize_text_field'
		);

		add_settings_field(
			'automatically_hide',
			esc_html__( 'Automatically Hide', 'helpful-pro' ),
			array( $this, 'automatically_hide_callback' ),
			'daexthefup_advanced_options',
			'daexthefup_advanced_settings_section'
		);

		register_setting(
			'daexthefup_advanced_options',
			'daexthefup_automatically_hide',
			'sanitize_text_field'
		);

		add_settings_field(
			'automatically_hide_number_of_days',
			esc_html__( 'Automatically Hide (Number of Days)', 'helpful-pro' ),
			array( $this, 'automatically_hide_number_of_days_callback' ),
			'daexthefup_advanced_options',
			'daexthefup_advanced_settings_section'
		);

		register_setting(
			'daexthefup_advanced_options',
			'daexthefup_automatically_hide_number_of_days',
			'sanitize_text_field'
		);
	}

	// Section Content ------------------------------------------------------------------------------------------------.
	public function position_callback( $args ) {

		$html  = '<select id="daexthefup_position" name="daexthefup_position" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_position' ) ),
			0,
			false
		) . ' value="0">' . esc_html__( 'Before Content', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_position' ) ),
			1,
			false
		) . ' value="1">' . esc_html__( 'After Content', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The position of the form.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function title_callback( $args ) {

		echo '<input maxlength="10000" type="text" id="daexthefup_title" name="daexthefup_title" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_title' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The title of the form.', 'helpful-pro' ) . '"></div>';
	}

	public function layout_callback( $args ) {

		$html  = '<select id="daexthefup_layout" name="daexthefup_layout" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_layout' ) ),
			0,
			false
		) . ' value="0">' . esc_html__( 'Side by Side', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_layout' ) ),
			1,
			false
		) . ' value="1">' . esc_html__( 'Stacked', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The type of layout of the form. Select "Side by Side" to display the form title and the rating buttons in the same row. Select "Stacked" to display the main title and the rating buttons in separate rows.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function alignment_callback( $args ) {

		$html  = '<select id="daexthefup_alignment" name="daexthefup_alignment" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_alignment' ) ),
			0,
			false
		) . ' value="0">' . esc_html__( 'Left', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_alignment' ) ),
			1,
			false
		) . ' value="1">' . esc_html__( 'Center', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_alignment' ) ),
			2,
			false
		) . ' value="2">' . esc_html__( 'Right', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The alignment of the elements displayed in the form.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function button_type_callback( $args ) {

		$html  = '<select id="daexthefup_button_type" name="daexthefup_button_type" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_button_type' ) ),
			'0',
			false
		) . ' value="0">' . esc_html__( 'Icon', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_button_type' ) ),
			'1',
			false
		) . ' value="1">' . esc_html__( 'Icon & Text', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_button_type' ) ),
			'2',
			false
		) . ' value="2">' . esc_html__( 'Text', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The type of rating buttons.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function show_rating_number_callback( $args ) {

		$html  = '<select id="daexthefup_show_rating_number" name="daexthefup_show_rating_number" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_show_rating_number' ) ),
			0,
			false
		) . ' value="0">' . esc_html__( 'No', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_show_rating_number' ) ),
			1,
			false
		) . ' value="1">' . esc_html__( 'Yes', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'Whether to display or not the number of feedback received. Note that this option is used only if the "Rating Button Type" option is set to "Icon & Text" or "Text".', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function positive_feedback_icon_callback( $args ) {

		$html  = '<select id="daexthefup_positive_feedback_icon" name="daexthefup_positive_feedback_icon" class="daext-display-none">';
		$html .= '<option ' . selected(
			get_option( 'daexthefup_positive_feedback_icon' ),
			'thumb-up',
			false
		) . ' value="thumb-up">' . esc_html__( 'Thumb Up', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			get_option( 'daexthefup_positive_feedback_icon' ),
			'happy-face',
			false
		) . ' value="happy-face">' . esc_html__( 'Happy Face', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The icon displayed in the positive rating button.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function positive_feedback_text_callback( $args ) {

		echo '<input maxlength="100" type="text" id="daexthefup_positive_feedback_text" name="daexthefup_positive_feedback_text" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_positive_feedback_text' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The text displayed in the positive rating button.', 'helpful-pro' ) . '"></div>';
	}

	public function negative_feedback_icon_callback( $args ) {

		$html  = '<select id="daexthefup_negative_feedback_icon" name="daexthefup_negative_feedback_icon" class="daext-display-none">';
		$html .= '<option ' . selected(
			get_option( 'daexthefup_negative_feedback_icon' ),
			'thumb-down',
			false
		) . ' value="thumb-down">' . esc_html__( 'Thumb Down', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			get_option( 'daexthefup_negative_feedback_icon' ),
			'sad-face',
			false
		) . ' value="sad-face">' . esc_html__( 'Sad Face', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The icon displayed in the negative rating button.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function negative_feedback_text_callback( $args ) {

		echo '<input maxlength="100" type="text" id="daexthefup_negative_feedback_text" name="daexthefup_negative_feedback_text" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_negative_feedback_text' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The text displayed in the negative rating button.', 'helpful-pro' ) . '"></div>';
	}

	public function comment_form_callback( $args ) {

		$html  = '<select id="daexthefup_comment_form" name="daexthefup_comment_form" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_comment_form' ) ),
			'0',
			false
		) . ' value="0">' . esc_html__( 'Always', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_comment_form' ) ),
			'1',
			false
		) . ' value="1">' . esc_html__( 'After Positive Rating', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_comment_form' ) ),
			'2',
			false
		) . ' value="2">' . esc_html__( 'After Negative rating', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_comment_form' ) ),
			'3',
			false
		) . ' value="3">' . esc_html__( 'Never', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'Select when to display the textarea used to collect a comment from the user.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function comment_form_textarea_label_positive_feedback_callback( $args ) {

		echo '<input maxlength="10000" type="text" id="daexthefup_comment_form_textarea_label_positive_feedback" name="daexthefup_comment_form_textarea_label_positive_feedback" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_comment_form_textarea_label_positive_feedback' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The textarea label displayed when a positive rating is selected.', 'helpful-pro' ) . '"></div>';
	}

	public function comment_form_textarea_label_negative_feedback_callback( $args ) {

		echo '<input maxlength="10000" type="text" id="daexthefup_comment_form_textarea_label_negative_feedback" name="daexthefup_comment_form_textarea_label_negative_feedback" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_comment_form_textarea_label_negative_feedback' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The textarea label displayed when a negative rating is selected.', 'helpful-pro' ) . '"></div>';
	}

	public function comment_form_textarea_placeholder_callback( $args ) {

		echo '<input maxlength="10000" type="text" id="daexthefup_comment_form_textarea_placeholder" name="daexthefup_comment_form_textarea_placeholder" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_comment_form_textarea_placeholder' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The placeholder of the textarea used to submit a comment.', 'helpful-pro' ) . '"></div>';
	}

	public function comment_form_button_submit_text_callback( $args ) {

		echo '<input maxlength="100" type="text" id="daexthefup_comment_form_button_submit_text" name="daexthefup_comment_form_button_submit_text" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_comment_form_button_submit_text' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The text of the button used to submit a comment.', 'helpful-pro' ) . '"></div>';
	}

	public function comment_form_button_cancel_text_callback( $args ) {

		echo '<input maxlength="100" type="text" id="daexthefup_comment_form_button_cancel_text" name="daexthefup_comment_form_button_cancel_text" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_comment_form_button_cancel_text' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The text of the button used to cancel a comment.', 'helpful-pro' ) . '"></div>';
	}

	public function successful_submission_text_callback( $args ) {

		echo '<input maxlength="10000" type="text" id="daexthefup_successful_submission_text" name="daexthefup_successful_submission_text" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_successful_submission_text' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'A message displayed after a successful submission of the form.', 'helpful-pro' ) . '"></div>';
	}

	public function background_callback( $args ) {

		$html  = '<select id="daexthefup_background" name="daexthefup_background" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_background' ) ),
			0,
			false
		) . ' value="0">' . esc_html__( 'No', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_background' ) ),
			1,
			false
		) . ' value="1">' . esc_html__( 'Yes', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'Whether to display or not a colored background for the form container.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}


	public function border_callback( $args ) {

		$html  = '<select id="daexthefup_border" name="daexthefup_border" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_border' ) ),
			0,
			false
		) . ' value="0">' . esc_html__( 'None', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_border' ) ),
			1,
			false
		) . ' value="1">' . esc_html__( 'Horizontal', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_border' ) ),
			2,
			false
		) . ' value="2">' . esc_html__( 'Vertical', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_border' ) ),
			3,
			false
		) . ' value="3">' . esc_html__( 'Complete', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The type of border of the form container.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	// Title ------------------------------------------------------------------------------------------------------------
	public function title_font_family_callback( $args ) {

		echo '<input maxlength="10000" type="text" id="daexthefup_title_font_family" name="daexthefup_title_font_family" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_title_font_family' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font family of the form title.', 'helpful-pro' ) . '"></div>';
	}

	public function title_font_size_callback( $args ) {

		echo '<input maxlength="7" type="text" id="daexthefup_title_font_size" name="daexthefup_title_font_size" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_title_font_size' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font size of the form title.', 'helpful-pro' ) . '"></div>';
	}

	public function title_font_style_callback( $args ) {

		$html  = '<select id="daexthefup_title_font_style" name="daexthefup_title_font_style" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_title_font_style' ) ),
			'normal',
			false
		) . ' value="normal">' . esc_html__( 'Normal', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_title_font_style' ) ),
			'italic',
			false
		) . ' value="italic">' . esc_html__( 'Italic', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_title_font_style' ) ),
			'oblique',
			false
		) . ' value="oblique">' . esc_html__( 'Oblique', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The font style of the form title.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function title_font_weight_callback( $args ) {

		$html  = '<select id="daexthefup_title_font_weight" name="daexthefup_title_font_weight" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_title_font_weight' ) ),
			'100',
			false
		) . ' value="100">' . esc_html__( '100', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_title_font_weight' ) ),
			'200',
			false
		) . ' value="200">' . esc_html__( '200', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_title_font_weight' ) ),
			'300',
			false
		) . ' value="300">' . esc_html__( '300', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_title_font_weight' ) ),
			'400',
			false
		) . ' value="400">' . esc_html__( '400', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_title_font_weight' ) ),
			'500',
			false
		) . ' value="500">' . esc_html__( '500', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_title_font_weight' ) ),
			'600',
			false
		) . ' value="600">' . esc_html__( '600', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_title_font_weight' ) ),
			'700',
			false
		) . ' value="700">' . esc_html__( '700', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_title_font_weight' ) ),
			'800',
			false
		) . ' value="800">' . esc_html__( '800', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_title_font_weight' ) ),
			'900',
			false
		) . ' value="900">' . esc_html__( '900', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The font weight of the form title.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function title_line_height_callback( $args ) {

		echo '<input maxlength="7" type="text" id="daexthefup_title_line_height" name="daexthefup_title_line_height" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_title_line_height' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The line height of the form title.', 'helpful-pro' ) . '"></div>';
	}

	public function rating_button_font_family_callback( $args ) {

		echo '<input maxlength="10000" type="text" id="daexthefup_rating_button_font_family" name="daexthefup_rating_button_font_family" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_rating_button_font_family' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font family of the rating buttons.', 'helpful-pro' ) . '"></div>';
	}

	public function rating_button_font_size_callback( $args ) {

		echo '<input maxlength="7" type="text" id="daexthefup_rating_button_font_size" name="daexthefup_rating_button_font_size" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_rating_button_font_size' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font size of the rating buttons.', 'helpful-pro' ) . '"></div>';
	}

	public function rating_button_font_style_callback( $args ) {

		$html  = '<select id="daexthefup_rating_button_font_style" name="daexthefup_rating_button_font_style" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_rating_button_font_style' ) ),
			0,
			false
		) . ' value="normal">' . esc_html__( 'Normal', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_rating_button_font_style' ) ),
			1,
			false
		) . ' value="italic">' . esc_html__( 'Italic', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_rating_button_font_style' ) ),
			1,
			false
		) . ' value="oblique">' . esc_html__( 'Oblique', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The font style of the rating buttons.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function rating_button_font_weight_callback( $args ) {

		$html  = '<select id="daexthefup_rating_button_font_weight" name="daexthefup_rating_button_font_weight" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_rating_button_font_weight' ) ),
			100,
			false
		) . ' value="100">' . esc_html__( '100', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_rating_button_font_weight' ) ),
			200,
			false
		) . ' value="200">' . esc_html__( '200', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_rating_button_font_weight' ) ),
			300,
			false
		) . ' value="300">' . esc_html__( '300', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_rating_button_font_weight' ) ),
			400,
			false
		) . ' value="400">' . esc_html__( '400', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_rating_button_font_weight' ) ),
			500,
			false
		) . ' value="500">' . esc_html__( '500', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_rating_button_font_weight' ) ),
			600,
			false
		) . ' value="600">' . esc_html__( '600', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_rating_button_font_weight' ) ),
			700,
			false
		) . ' value="700">' . esc_html__( '700', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_rating_button_font_weight' ) ),
			800,
			false
		) . ' value="800">' . esc_html__( '800', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_rating_button_font_weight' ) ),
			900,
			false
		) . ' value="900">' . esc_html__( '900', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The font weight of the rating buttons.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function rating_button_line_height_callback( $args ) {

		echo '<input maxlength="7" type="text" id="daexthefup_rating_button_line_height" name="daexthefup_rating_button_line_height" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_rating_button_line_height' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The line height of the rating buttons.', 'helpful-pro' ) . '"></div>';
	}

	public function base_font_family_callback( $args ) {

		echo '<input maxlength="10000" type="text" id="daexthefup_base_font_family" name="daexthefup_base_font_family" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_base_font_family' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font family of the textarea label, character counter, and successful submission message.', 'helpful-pro' ) . '"></div>';
	}

	public function base_font_size_callback( $args ) {

		echo '<input maxlength="7" type="text" id="daexthefup_base_font_size" name="daexthefup_base_font_size" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_base_font_size' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font family of the textarea label, character counter, and successful submission message.', 'helpful-pro' ) . '"></div>';
	}

	public function base_font_style_callback( $args ) {

		$html  = '<select id="daexthefup_base_font_style" name="daexthefup_base_font_style" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_base_font_style' ) ),
			0,
			false
		) . ' value="normal">' . esc_html__( 'Normal', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_base_font_style' ) ),
			1,
			false
		) . ' value="italic">' . esc_html__( 'Italic', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_base_font_style' ) ),
			1,
			false
		) . ' value="oblique">' . esc_html__( 'Oblique', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The font style of the textarea label, character counter, and successful submission message.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function base_font_weight_callback( $args ) {

		$html  = '<select id="daexthefup_base_font_weight" name="daexthefup_base_font_weight" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_base_font_weight' ) ),
			100,
			false
		) . ' value="100">' . esc_html__( '100', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_base_font_weight' ) ),
			200,
			false
		) . ' value="200">' . esc_html__( '200', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_base_font_weight' ) ),
			300,
			false
		) . ' value="300">' . esc_html__( '300', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_base_font_weight' ) ),
			400,
			false
		) . ' value="400">' . esc_html__( '400', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_base_font_weight' ) ),
			500,
			false
		) . ' value="500">' . esc_html__( '500', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_base_font_weight' ) ),
			600,
			false
		) . ' value="600">' . esc_html__( '600', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_base_font_weight' ) ),
			700,
			false
		) . ' value="700">' . esc_html__( '700', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_base_font_weight' ) ),
			800,
			false
		) . ' value="800">' . esc_html__( '800', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_base_font_weight' ) ),
			900,
			false
		) . ' value="900">' . esc_html__( '900', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The font weight of the textarea label, character counter, and successful submission message.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function base_line_height_callback( $args ) {

		echo '<input maxlength="10000" type="text" id="daexthefup_base_line_height" name="daexthefup_base_line_height" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_base_line_height' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The line height of the textarea label, character counter, and successful submission message.', 'helpful-pro' ) . '"></div>';
	}

	public function comment_textarea_font_family_callback( $args ) {

		echo '<input maxlength="10000" type="text" id="daexthefup_comment_textarea_font_family" name="daexthefup_comment_textarea_font_family" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_comment_textarea_font_family' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font family of the textarea.', 'helpful-pro' ) . '"></div>';
	}

	public function comment_textarea_font_size_callback( $args ) {

		echo '<input maxlength="7" type="text" id="daexthefup_comment_textarea_font_size" name="daexthefup_comment_textarea_font_size" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_comment_textarea_font_size' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font size of the textarea.', 'helpful-pro' ) . '"></div>';
	}

	public function comment_textarea_font_style_callback( $args ) {

		$html  = '<select id="daexthefup_comment_textarea_font_style" name="daexthefup_comment_textarea_font_style" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_comment_textarea_font_style' ) ),
			0,
			false
		) . ' value="normal">' . esc_html__( 'Normal', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_comment_textarea_font_style' ) ),
			1,
			false
		) . ' value="italic">' . esc_html__( 'Italic', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_comment_textarea_font_style' ) ),
			1,
			false
		) . ' value="oblique">' . esc_html__( 'Oblique', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The font style of the textarea.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function comment_textarea_font_weight_callback( $args ) {

		$html  = '<select id="daexthefup_comment_textarea_font_weight" name="daexthefup_comment_textarea_font_weight" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_comment_textarea_font_weight' ) ),
			100,
			false
		) . ' value="100">' . esc_html__( '100', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_comment_textarea_font_weight' ) ),
			200,
			false
		) . ' value="200">' . esc_html__( '200', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_comment_textarea_font_weight' ) ),
			300,
			false
		) . ' value="300">' . esc_html__( '300', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_comment_textarea_font_weight' ) ),
			400,
			false
		) . ' value="400">' . esc_html__( '400', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_comment_textarea_font_weight' ) ),
			500,
			false
		) . ' value="500">' . esc_html__( '500', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_comment_textarea_font_weight' ) ),
			600,
			false
		) . ' value="600">' . esc_html__( '600', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_comment_textarea_font_weight' ) ),
			700,
			false
		) . ' value="700">' . esc_html__( '700', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_comment_textarea_font_weight' ) ),
			800,
			false
		) . ' value="800">' . esc_html__( '800', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_comment_textarea_font_weight' ) ),
			900,
			false
		) . ' value="900">' . esc_html__( '900', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The font weight of the textarea.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function comment_textarea_line_height_callback( $args ) {

		echo '<input maxlength="7" type="text" id="daexthefup_comment_textarea_line_height" name="daexthefup_comment_textarea_line_height" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_comment_textarea_line_height' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The line height of the textarea.', 'helpful-pro' ) . '"></div>';
	}

	public function button_font_family_callback( $args ) {

		echo '<input maxlength="10000" type="text" id="daexthefup_button_font_family" name="daexthefup_button_font_family" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_button_font_family' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font family of the standard buttons.', 'helpful-pro' ) . '"></div>';
	}

	public function button_font_size_callback( $args ) {

		echo '<input maxlength="7" type="text" id="daexthefup_button_font_size" name="daexthefup_button_font_size" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_button_font_size' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font size of the standard buttons.', 'helpful-pro' ) . '"></div>';
	}

	public function button_font_style_callback( $args ) {

		$html  = '<select id="daexthefup_button_font_style" name="daexthefup_button_font_style" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_button_font_style' ) ),
			0,
			false
		) . ' value="normal">' . esc_html__( 'Normal', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_button_font_style' ) ),
			1,
			false
		) . ' value="italic">' . esc_html__( 'Italic', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_button_font_style' ) ),
			1,
			false
		) . ' value="oblique">' . esc_html__( 'Oblique', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The font style of the standard buttons.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function button_font_weight_callback( $args ) {

		$html  = '<select id="daexthefup_button_font_weight" name="daexthefup_button_font_weight" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_button_font_weight' ) ),
			100,
			false
		) . ' value="100">' . esc_html__( '100', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_button_font_weight' ) ),
			200,
			false
		) . ' value="200">' . esc_html__( '200', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_button_font_weight' ) ),
			300,
			false
		) . ' value="300">' . esc_html__( '300', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_button_font_weight' ) ),
			400,
			false
		) . ' value="400">' . esc_html__( '400', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_button_font_weight' ) ),
			500,
			false
		) . ' value="500">' . esc_html__( '500', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_button_font_weight' ) ),
			600,
			false
		) . ' value="600">' . esc_html__( '600', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_button_font_weight' ) ),
			700,
			false
		) . ' value="700">' . esc_html__( '700', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_button_font_weight' ) ),
			800,
			false
		) . ' value="800">' . esc_html__( '800', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_button_font_weight' ) ),
			900,
			false
		) . ' value="900">' . esc_html__( '900', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The font weight of the standard buttons.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function button_line_height_callback( $args ) {

		echo '<input maxlength="7" type="text" id="daexthefup_button_line_height" name="daexthefup_button_line_height" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_button_line_height' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The line height of the standard buttons.', 'helpful-pro' ) . '"></div>';
	}

	// Section Colors ---------------------------------------------------------------------------------------------------
	public function title_font_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_title_font_color" name="daexthefup_title_font_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_title_font_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font color of the form title.', 'helpful-pro' ) . '"></div>';
	}

	public function rating_button_font_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_rating_button_font_color" name="daexthefup_rating_button_font_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_rating_button_font_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font color of the rating buttons.', 'helpful-pro' ) . '"></div>';
	}

	public function rating_button_background_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_rating_button_background_color" name="daexthefup_rating_button_background_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_rating_button_background_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The background color of the button used to submit a positive rating.', 'helpful-pro' ) . '"></div>';
	}

	public function button_icon_primary_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_button_icon_primary_color" name="daexthefup_button_icon_primary_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_button_icon_primary_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The primary color of the icons displayed in the rating buttons.', 'helpful-pro' ) . '"></div>';
	}

	public function button_icon_secondary_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_button_icon_secondary_color" name="daexthefup_button_icon_secondary_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_button_icon_secondary_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The secondary color of the icons displayed in the rating buttons.', 'helpful-pro' ) . '"></div>';
	}

	public function button_icon_primary_color_positive_selected_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_button_icon_primary_color_positive_selected" name="daexthefup_button_icon_primary_color_positive_selected" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_button_icon_primary_color_positive_selected' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The primary color of the selected positive icon displayed in the rating buttons.', 'helpful-pro' ) . '"></div>';
	}

	public function button_icon_secondary_color_positive_selected_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_button_icon_secondary_color_positive_selected" name="daexthefup_button_icon_secondary_color_positive_selected" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_button_icon_secondary_color_positive_selected' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The secondary color of the selected positive icon displayed in the rating buttons.', 'helpful-pro' ) . '"></div>';
	}

	public function button_icon_primary_color_negative_selected_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_button_icon_primary_color_negative_selected" name="daexthefup_button_icon_primary_color_negative_selected" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_button_icon_primary_color_negative_selected' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The primary color of the selected negative icon displayed in the rating buttons.', 'helpful-pro' ) . '"></div>';
	}

	public function button_icon_secondary_color_negative_selected_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_button_icon_secondary_color_negative_selected" name="daexthefup_button_icon_secondary_color_negative_selected" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_button_icon_secondary_color_negative_selected' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The secondary color of the selected negative icon displayed in the rating buttons.', 'helpful-pro' ) . '"></div>';
	}

	public function button_icons_border_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_button_icons_border_color" name="daexthefup_button_icons_border_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_button_icons_border_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The border color of the icons displayed in the rating buttons.', 'helpful-pro' ) . '"></div>';
	}

	public function label_font_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_label_font_color" name="daexthefup_label_font_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_label_font_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font color of the textarea label.', 'helpful-pro' ) . '"></div>';
	}

	public function character_counter_font_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_character_counter_font_color" name="daexthefup_character_counter_font_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_character_counter_font_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font color of the character counter displayed above the textarea.', 'helpful-pro' ) . '"></div>';
	}

	public function comment_textarea_font_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_comment_textarea_font_color" name="daexthefup_comment_textarea_font_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_comment_textarea_font_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font color of the textarea label.', 'helpful-pro' ) . '"></div>';
	}

	public function comment_textarea_background_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_comment_textarea_background_color" name="daexthefup_comment_textarea_background_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_comment_textarea_background_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The background color of the textarea.', 'helpful-pro' ) . '"></div>';
	}

	public function comment_textarea_border_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_comment_textarea_border_color" name="daexthefup_comment_textarea_border_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_comment_textarea_border_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The border color of the textarea.', 'helpful-pro' ) . '"></div>';
	}

	public function comment_textarea_border_color_selected_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_comment_textarea_border_color_selected" name="daexthefup_comment_textarea_border_color_selected" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_comment_textarea_border_color_selected' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The color used for the border of a selected textarea.', 'helpful-pro' ) . '"></div>';
	}

	public function primary_button_background_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_primary_button_background_color" name="daexthefup_primary_button_background_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_primary_button_background_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The background color of the primary standard button.', 'helpful-pro' ) . '"></div>';
	}

	public function primary_button_border_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_primary_button_border_color" name="daexthefup_primary_button_border_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_primary_button_border_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The border color of the primary standard button.', 'helpful-pro' ) . '"></div>';
	}

	public function primary_button_font_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_primary_button_font_color" name="daexthefup_primary_button_font_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_primary_button_font_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font color of the primary standard button.', 'helpful-pro' ) . '"></div>';
	}

	public function secondary_button_background_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_secondary_button_background_color" name="daexthefup_secondary_button_background_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_secondary_button_background_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The background color of the secondary standard button.', 'helpful-pro' ) . '"></div>';
	}

	public function secondary_button_border_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_secondary_button_border_color" name="daexthefup_secondary_button_border_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_secondary_button_border_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The border color of the secondary standard button.', 'helpful-pro' ) . '"></div>';
	}

	public function secondary_button_font_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_secondary_button_font_color" name="daexthefup_secondary_button_font_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_secondary_button_font_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font color of the secondary standard button.', 'helpful-pro' ) . '"></div>';
	}

	public function successful_submission_font_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_successful_submission_font_color" name="daexthefup_successful_submission_font_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_successful_submission_font_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The font color of the message displayed after a successful submission of the form.', 'helpful-pro' ) . '"></div>';
	}

	public function background_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_background_color" name="daexthefup_background_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_background_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The background color of the form container.', 'helpful-pro' ) . '"></div>';
	}

	public function border_color_callback( $args ) {

		echo '<input class="wp-color-picker" maxlength="7" type="text" id="daexthefup_border_color" name="daexthefup_border_color" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_border_color' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The border color of the form container.', 'helpful-pro' ) . '"></div>';
	}

	// Section Spacing --------------------------------------------------------------------------------------------------

	public function container_horizontal_padding_callback( $args ) {

		echo '<input maxlength="7" type="text" id="daexthefup_container_horizontal_padding" name="daexthefup_container_horizontal_padding" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_container_horizontal_padding' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The horizontal padding of the form container.', 'helpful-pro' ) . '"></div>';
	}

	public function container_vertical_padding_callback( $args ) {

		echo '<input maxlength="7" type="text" id="daexthefup_container_vertical_padding" name="daexthefup_container_vertical_padding" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_container_vertical_padding' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The vertical padding of the form container.', 'helpful-pro' ) . '"></div>';
	}

	public function container_horizontal_margin_callback( $args ) {

		echo '<input maxlength="7" type="text" id="daexthefup_container_horizontal_margin" name="daexthefup_container_horizontal_margin" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_container_horizontal_margin' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The horizontal margin of the form container.', 'helpful-pro' ) . '"></div>';
	}

	public function container_vertical_margin_callback( $args ) {

		echo '<input maxlength="7" type="text" id="daexthefup_container_vertical_margin" name="daexthefup_container_vertical_margin" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_container_vertical_margin' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The vertical margin of the form container.', 'helpful-pro' ) . '"></div>';
	}

	public function border_radius_callback( $args ) {

		echo '<input maxlength="7" type="text" id="daexthefup_border_radius" name="daexthefup_border_radius" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_border_radius' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The border radius used for buttons, input fields, and containers.', 'helpful-pro' ) . '"></div>';
	}

	// Section Analysis -------------------------------------------------------------------------------------------------
	public function set_max_execution_time_callback( $args ) {

		$html  = '<select id="daexthefup_set_max_execution_time" name="daexthefup_set_max_execution_time" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_set_max_execution_time' ) ),
			0,
			false
		) . ' value="0">' . esc_html__( 'No', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_set_max_execution_time' ) ),
			1,
			false
		) . ' value="1">' . esc_html__( 'Yes', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'Select "Yes" to enable your custom "Max Execution Time Value" on long running scripts.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function set_max_execution_time_validation( $input ) {

		$input = sanitize_text_field( $input );

		return intval( $input, 10 ) == 1 ? '1' : '0';
	}

	public function max_execution_time_value_callback( $args ) {

		$html  = '<input maxlength="7" type="text" id="daexthefup_max_execution_time_value" name="daexthefup_max_execution_time_value" class="regular-text" value="' . intval(
			get_option( 'daexthefup_max_execution_time_value' ),
			10
		) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This value determines the maximum number of seconds allowed to execute long running scripts.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function max_execution_time_value_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( ! preg_match( $this->shared->regex_number_ten_digits, $input ) or intval(
			$input,
			10
		) < 1 or intval( $input, 10 ) > 1000000 ) {
			add_settings_error(
				'daexthefup_max_execution_time_value',
				'daexthefup_max_execution_time_value',
				esc_html__( 'Please enter a number from 1 to 1000000 in the "Max Execution Time Value" option.', 'helpful-pro' )
			);
			$output = get_option( 'daexthefup_max_execution_time_value' );
		} else {
			$output = $input;
		}

		return intval( $output, 10 );
	}

	public function set_memory_limit_callback( $args ) {

		$html  = '<select id="daexthefup_set_memory_limit" name="daexthefup_set_memory_limit" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_set_memory_limit' ) ),
			0,
			false
		) . ' value="0">' . esc_html__( 'No', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_set_memory_limit' ) ),
			1,
			false
		) . ' value="1">' . esc_html__( 'Yes', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'Select "Yes" to enable your custom "Memory Limit Value" on long running scripts.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function set_memory_limit_validation( $input ) {

		$input = sanitize_text_field( $input );

		return intval( $input, 10 ) == 1 ? '1' : '0';
	}

	public function memory_limit_value_callback( $args ) {

		$html  = '<input maxlength="7" type="text" id="daexthefup_memory_limit_value" name="daexthefup_memory_limit_value" class="regular-text" value="' . intval(
			get_option( 'daexthefup_memory_limit_value' ),
			10
		) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This value determines the PHP memory limit in megabytes allowed to execute long running scripts.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function memory_limit_value_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( ! preg_match( $this->shared->regex_number_ten_digits, $input ) or intval(
			$input,
			10
		) < 1 or intval( $input, 10 ) > 1000000 ) {
			add_settings_error(
				'daexthefup_memory_limit_value',
				'daexthefup_memory_limit_value',
				esc_html__( 'Please enter a number from 1 to 1000000 in the "Memory Limit Value" option.', 'helpful-pro' )
			);
			$output = get_option( 'daexthefup_memory_limit_value' );
		} else {
			$output = $input;
		}

		return intval( $output, 10 );
	}

	public function limit_posts_analysis_callback( $args ) {

		echo '<input maxlength="7" maxlength="100" type="text" id="daexthefup_limit_posts_analysis" name="daexthefup_limit_posts_analysis" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_limit_posts_analysis' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'With this options you can determine the maximum number of posts analyzed to get information about the feedback. If you select for example "10000", the analysis performed by the plugin will use your latest "10000" posts.', 'helpful-pro' ) . '"></div>';
	}

	public function analysis_post_types_callback( $args ) {

		$analysis_post_types_a = get_option( 'daexthefup_analysis_post_types' );

		$available_analysis_post_types_a = get_post_types(
			array(
				'public'  => true,
				'show_ui' => true,
			)
		);

		// Remove the "attachment" post type
		$available_analysis_post_types_a = array_diff( $available_analysis_post_types_a, array( 'attachment' ) );

		$html = '<select id="daexthefup_analysis_post_types" name="daexthefup_analysis_post_types[]" class="daext-display-none" multiple>';

		foreach ( $available_analysis_post_types_a as $single_post_type ) {
			if ( is_array( $analysis_post_types_a ) and in_array( $single_post_type, $analysis_post_types_a ) ) {
				$selected = 'selected';
			} else {
				$selected = '';
			}
			$post_type_obj = get_post_type_object( $single_post_type );
			$html         .= '<option value="' . $single_post_type . '" ' . $selected . '>' . esc_html( $post_type_obj->label ) . '</option>';
		}

		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'With this option you are able to determine the post types listed in the "Statistics" menu.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function analysis_post_types_validation( $input ) {

		if ( ! is_array( $input ) ) {
			add_settings_error(
				'daexthefup_analysis_post_types',
				'daexthefup_analysis_post_types',
				esc_html__( 'Please at least one post type in the "Post Types" option.', 'helpful-pro' )
			);
			$output = get_option( 'daexthefup_analysis_post_types' );

		} else {
			$output = $input;
		}

		return $output;
	}

	// Section Capabilities ----------------------------------------------------------
	public function statistics_menu_capability_callback( $args ) {

		echo '<input maxlength="100" type="text" id="daexthefup_statistics_menu_capability" name="daexthefup_statistics_menu_capability" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_statistics_menu_capability' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The capability required to get access on the "Statistics" menu.', 'helpful-pro' ) . '"></div>';
	}

	public function maintenance_menu_capability_callback( $args ) {

		echo '<input maxlength="100" type="text" id="daexthefup_maintenance_menu_capability" name="daexthefup_maintenance_menu_capability" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_maintenance_menu_capability' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The capability required to get access on the "Maintenance" menu.', 'helpful-pro' ) . '"></div>';
	}

	// Section Advanced ----------------------------------------------------------
	public function test_mode_callback( $args ) {

		$html  = '<select id="daexthefup_test_mode" name="daexthefup_test_mode" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_test_mode' ) ),
			0,
			false
		) . ' value="0">' . esc_html__( 'No', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_test_mode' ) ),
			1,
			false
		) . ' value="1">' . esc_html__( 'Yes', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'With the test mode enabled, the feedback form will be applied in the front-end only if the user that is requesting the page is the website administrator.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function assets_mode_callback( $args ) {

		$html  = '<select id="daexthefup_assets_mode" name="daexthefup_assets_mode" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_assets_mode' ) ),
			0,
			false
		) . ' value="0">' . esc_html__( 'Development', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_assets_mode' ) ),
			1,
			false
		) . ' value="1">' . esc_html__( 'Production', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'With "Development" selected the development version of the JavaScript files used by the plugin will be loaded on the front-end. With "Production" selected the minified version of the JavaScript file used by the plugin will be loaded on the front-end.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function post_types_callback( $args ) {

		$post_types_a = get_option( 'daexthefup_post_types' );

		$available_post_types_a = get_post_types(
			array(
				'public'  => true,
				'show_ui' => true,
			)
		);

		// Remove the "attachment" post type
		$available_post_types_a = array_diff( $available_post_types_a, array( 'attachment' ) );

		$html = '<select id="daexthefup_post_types" name="daexthefup_post_types[]" class="daext-display-none" multiple>';

		foreach ( $available_post_types_a as $single_post_type ) {
			if ( is_array( $post_types_a ) and in_array( $single_post_type, $post_types_a ) ) {
				$selected = 'selected';
			} else {
				$selected = '';
			}
			$post_type_obj = get_post_type_object( $single_post_type );
			$html         .= '<option value="' . $single_post_type . '" ' . $selected . '>' . esc_html( $post_type_obj->label ) . '</option>';
		}

		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'With this option, you are able to determine to which post types the form will be applied.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function post_types_validation( $input ) {

		if ( ! is_array( $input ) ) {
			add_settings_error(
				'daexthefup_post_types',
				'daexthefup_post_types',
				esc_html__( 'Please at least one post type in the "Post Types" option.', 'helpful-pro' )
			);
			$output = get_option( 'daexthefup_post_types' );

		} else {
			$output = $input;
		}

		return $output;
	}

	public function pagination_items_callback( $args ) {

		$html  = '<select id="daexthefup_pagination_items" name="daexthefup_pagination_items" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_pagination_items' ) ),
			10,
			false
		) . ' value="10">' . esc_html__( '10', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_pagination_items' ) ),
			20,
			false
		) . ' value="20">' . esc_html__( '20', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_pagination_items' ) ),
			30,
			false
		) . ' value="30">' . esc_html__( '30', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_pagination_items' ) ),
			40,
			false
		) . ' value="40">' . esc_html__( '40', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_pagination_items' ) ),
			50,
			false
		) . ' value="50">' . esc_html__( '50', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_pagination_items' ) ),
			60,
			false
		) . ' value="60">' . esc_html__( '60', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_pagination_items' ) ),
			70,
			false
		) . ' value="70">' . esc_html__( '70', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_pagination_items' ) ),
			80,
			false
		) . ' value="80">' . esc_html__( '80', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_pagination_items' ) ),
			90,
			false
		) . ' value="90">' . esc_html__( '90', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_pagination_items' ) ),
			100,
			false
		) . ' value="100">' . esc_html__( '100', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This options determines the number of items per page displayed in the "Statistics" menu.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function google_font_url_callback( $args ) {

		echo '<input maxlength="2048" type="text" id="daexthefup_google_font_url" name="daexthefup_google_font_url" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_google_font_url' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'Load one or more Google Fonts in the front-end of your website by entering the embed code URL in this option.', 'helpful-pro' ) . '"></div>';
	}

	public function textarea_characters_callback( $args ) {

		echo '<input maxlength="7" type="text" id="daexthefup_textarea_characters" name="daexthefup_textarea_characters" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_textarea_characters' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'The maximum number of characters allowed in the textarea used to submit a comment.', 'helpful-pro' ) . '"></div>';
	}

	public function unique_submission_callback( $args ) {

		$html  = '<select id="daexthefup_unique_submission" name="daexthefup_unique_submission" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_unique_submission' ) ),
			0,
			false
		) . ' value="0">' . esc_html__( 'No check', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_unique_submission' ) ),
			1,
			false
		) . ' value="1">' . esc_html__( 'Check cookies', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_unique_submission' ) ),
			2,
			false
		) . ' value="2">' . esc_html__( 'Check IP', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_unique_submission' ) ),
			3,
			false
		) . ' value="3">' . esc_html__( 'Check cookies and IP', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'Use cookies and IP address to prevent multiple form submissions.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function cookie_expiration_callback( $args ) {

		$html  = '<select id="daexthefup_cookie_expiration" name="daexthefup_cookie_expiration" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_cookie_expiration' ) ),
			0,
			false
		) . ' value="0">' . esc_html__( 'Unlimited', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_cookie_expiration' ) ),
			1,
			false
		) . ' value="1">' . esc_html__( 'One Hour', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_cookie_expiration' ) ),
			2,
			false
		) . ' value="2">' . esc_html__( 'One Day', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_cookie_expiration' ) ),
			3,
			false
		) . ' value="3">' . esc_html__( 'One Week', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_cookie_expiration' ) ),
			4,
			false
		) . ' value="4">' . esc_html__( 'One Month', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_cookie_expiration' ) ),
			5,
			false
		) . ' value="5">' . esc_html__( 'Three Months', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_cookie_expiration' ) ),
			6,
			false
		) . ' value="6">' . esc_html__( 'Six Months', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_cookie_expiration' ) ),
			7,
			false
		) . ' value="7">' . esc_html__( 'One Year', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The amount of time the cookies used to prevent multiple form submissions should be stored.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function required_capability_callback( $args ) {

		echo '<input maxlength="100" type="text" id="daexthefup_required_capability" name="daexthefup_required_capability" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_required_capability' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'Use this option to display the form only to users with the specified capability. Leave this field empty to not check the user capability.', 'helpful-pro' ) . '"></div>';
	}

	public function character_counter_callback( $args ) {

		$html  = '<select id="daexthefup_character_counter" name="daexthefup_character_counter" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_character_counter' ) ),
			0,
			false
		) . ' value="0">' . esc_html__( 'Disabled', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_character_counter' ) ),
			1,
			false
		) . ' value="1">' . esc_html__( 'Enabled', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'Whether to enable or disable the character counter.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function automatically_hide_callback( $args ) {

		$html  = '<select id="daexthefup_automatically_hide" name="daexthefup_automatically_hide" class="daext-display-none">';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_automatically_hide' ) ),
			0,
			false
		) . ' value="0">' . esc_html__( 'Disabled', 'helpful-pro' ) . '</option>';
		$html .= '<option ' . selected(
			intval( get_option( 'daexthefup_automatically_hide' ) ),
			1,
			false
		) . ' value="1">' . esc_html__( 'Enabled', 'helpful-pro' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'Automatically hide the form on old posts.', 'helpful-pro' ) . '"></div>';

		echo $html;
	}

	public function automatically_hide_number_of_days_callback( $args ) {

		echo '<input maxlength="100" type="text" id="daexthefup_automatically_hide_number_of_days" name="daexthefup_automatically_hide_number_of_days" class="regular-text" value="' . esc_attr( get_option( 'daexthefup_automatically_hide_number_of_days' ) ) . '" />';
		echo '<div class="help-icon" title="' . esc_attr__( 'Specify the number of days used to identify an old post. This option is only used when the "Automatically Hide" option is enabled.', 'helpful-pro' ) . '"></div>';
	}
}
