<?php
/**
 * This file is used for the help page.
 *
 * @package helpful-pro
 */

if ( ! current_user_can( 'manage_options' ) ) {
	wp_die( esc_attr__( 'You do not have sufficient permissions to access this page.', 'helpful-pro' ) );
}

?>

<!-- output -->

<div class="wrap">

	<h2><?php esc_html_e( 'Helpful - Help', 'helpful-pro' ); ?></h2>

	<div id="daext-menu-wrapper">

		<p><?php esc_html_e( 'Visit the resources below to find your answers or to ask questions directly to the plugin developers.', 'helpful-pro' ); ?></p>
		<ul>
			<li><a href="https://daext.com/doc/helpful-pro/"><?php esc_html_e( 'Plugin Documentation', 'helpful-pro' ); ?></li>
			<li><a href="https://daext.com/support/"><?php esc_html_e( 'Support Conditions', 'helpful-pro' ); ?></li>
			<li><a href="https://daext.com"><?php esc_html_e( 'Developer Website', 'helpful-pro' ); ?></a></li>
			<li>
				<a href="https://wordpress.org/plugins/daext-helpful/"><?php esc_html_e( 'WordPress.org Plugin Page', 'helpful-pro' ); ?></a></li>
			<li>
				<a href="https://wordpress.org/support/plugin/daext-helpful/"><?php esc_html_e( 'WordPress.org Support Forum', 'helpful-pro' ); ?></a></li>
		</ul>
		<p>

	</div>

</div>